# HP .spec for HP uefi flash utility kernel module rpm

## 
# Hewlett-Packard Company Confidential 
# (C) Copyright 2014 Hewlett-Packard Development Company, L.P.
# All rights reserved.
#
# Disclaimer of Warranty: This software is experimental and
# provided "as-is" by Hewlett-Packard Development Company,
# LP. ("HP")  HP shall have no obligation to maintain or
# support this software.  HP makes no express or implied
# warranty of any kind regarding this software including any
# warranties of merchantability, fitness for a particular
# purpose, title or non-infringement.  HP shall not be liable
# for any direct, indirect, special, incidental, or consequential
# damages, whether based on contract, tort or any other legal
# theory, in connection with or arising out of the furnishing,
# performance or use of this software.
## 
## kernel version
# if kversion isn't defined on rpm build line, build against current kernel
#%{!?kversion: %define kversion %(uname -r)}

%define kversion %(uname -r)
%define srcDir %{name}-%{version}
%define targetArch x86_64

# hint: this can he overridden with "--define kversion foo" on the rpmbuild command line, e.g.
# --define "kversion 2.6.16-1.2096_FC5"

## Kernel Variants
# This spec only meant for currently running kernel. 

%define logFile /var/log/hp-lxbios.log
%define targetDir /lib/modules/%{kversion}/kernel/drivers/hpuefi

Name:       hpuefi-mod
Version:    3.00
Release:    1
Summary:    HP FLASH: utility kernel module for UEFI Linux HP systems

License:    Redistributable, no modification permitted
Group:      System Environment/Kernel
#URL:        http://www.

## Source is created from these files: 
Source0:     %{srcDir}.tgz

ExclusiveOS: linux
BuildRoot: %{_tmppath}/%{name}-%{version}-%(%{__id_u} -n)
#ExclusiveArch: i386 x86_64

%description
The hp flash %{version} BIOS flash utility kernel module for UEFI 
systems running kernel %{kversion}.  This is intended ONLY for 
Z-class workstations.

Install and build this source RPM for all desired kernels. Process
below creates kernel-specific matched binary modules for installation
(based upon current running kernel):

  1. rpm -ivh hpuefi-mod-*.src.rpm
  2. cd ${HOME}/rpmbuild/SPECS		# wherever _topdir defined
  3. rpmbuild -bb hpuefi-mod.spec
  4. cd ${HOME}/rpmbuild/RPMS/`uname -m`
  5. sudo rpm -ivh hpuefi-mod-*.`uname -m`.rpm

Note that output version numbers will be matched to active kernel.


%prep
%setup -q -c -a 0

%build
[ -n $RPM_BUILD_ROOT -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p %{buildroot}
cd %{srcDir}
make


%install
rm -rf $RPM_BUILD_ROOT
install -D -m 0644 %{srcDir}/hpuefi.ko $RPM_BUILD_ROOT/%{targetDir}/hpuefi.ko
chmod u+x $RPM_BUILD_ROOT/%{targetDir}/hpuefi.ko
install -D -m 0644 %{srcDir}/mkdevhpuefi $RPM_BUILD_ROOT/%{targetDir}/mkdevhpuefi
chmod u+x $RPM_BUILD_ROOT/%{targetDir}/mkdevhpuefi


%clean
[ -n $RPM_BUILD_ROOT -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT


%post
# Register the module
depmod
modprobe hpuefi

# Create dev file
%{targetDir}/mkdevhpuefi

%postun
depmod
if [ -c /dev/hpuefi ]; 
then 
  /bin/rm -f /dev/hpuefi 
fi

%files
%{targetDir}
%{targetDir}/hpuefi.ko
%{targetDir}/mkdevhpuefi

%changelog
* Wed Dec 19 2018 <@hp.com>
- Updated to version 3.00
* Thu Sep 20 2018 <@hp.com>
- Updated to version 2.00
* Tue Oct 21 2014 <@hp.com>
- Initial package creation.  

